package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCzplpNew;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.sy.SYService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@RestController
@RequestMapping("/dmSygdMx")
public class DmSygdMxController {

    @Autowired
    private DmSygdMxService service;
    @Autowired
    private EmSbcnpService emSbcnpService;

    @Autowired
    private EmGcrlService gcrlService;

    @PostMapping("cgjhdhqk")
    public ResultBean<?> cgjhdhqk(@RequestBody Map<String,Object> map){
        return new ResultBean<>(service.cgjhdhqk(map));
    }

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmSygdMx sygd){
       List<DmSygdMx> list= service.list(new QueryWrapper<DmSygdMx>()
               .eq(StrUtil.isNotEmpty(sygd.getDcCh()),"dc_ch",sygd.getDcCh())
               .eq(StrUtil.isNotEmpty(sygd.getDcPl()),"dc_pl",sygd.getDcPl())
               .ge(StrUtil.isNotEmpty(sygd.getBeginTime()),"jssj",sygd.getBeginTime())
               .le(StrUtil.isNotEmpty(sygd.getEndTime()),"jssj",
                       DateUtil.endOfMonth(DateUtil.parseDate(sygd.getEndTime())).toString("yyyy/MM/dd"))
                       .orderByAsc("jssj,dc_ch,dc_pl")
                );
        Map map=new HashMap();
       if (list.size()>0){
           String beginTime=list.get(0).getJssj();
           String endTime=list.get(list.size()-1).getJssj();
           List<EmGcrl> emGcrls= gcrlService.list(new QueryWrapper<EmGcrl>().select("gl").between("gl",beginTime,endTime).eq("xxr","0"));
           List<String> gcrl = emGcrls.stream().map(EmGcrl::getGl).collect(Collectors.toList());
           map.put("gcrl",gcrl);
       }
      map.put("list",list);
      return new ResultBean(map);
    }

    @RequestMapping("/saveByDcch")
    @AuthFunction
    public ResultBean saveByDcch(@RequestBody HashMap<String, List<Object>> map ){
        return null;
    }

    @RequestMapping("/symxhz")
    @AuthFunction
    public ResultBean symxhz(@RequestBody List<DmSygdMx> list){
        Map<String,Object> map=new HashMap<>();
        //1.根据上料时间 从近到远排序
        list = list.stream()
                .filter(mx -> Objects.nonNull(mx.getJssj()))
                .sorted(Comparator.comparing(DmSygdMx::getJssj, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
        //2.时间范围内线表计划数据
        String year = list.get(0).getJssj().substring(0, 4);
        String begin = list.get(0).getJssj().substring(5, 7);
        String end = list.get(list.size() - 1).getJssj().substring(5, 7);

        map.put("xbList",service.getXBList(list,year,begin,end));
        map.put("plList",service.getPl(list.get(0).getJssj(),list.get(list.size() - 1).getJssj()));
        map.put("kwList",service.getKwList(list,list.get(0).getJssj(),list.get(list.size() - 1).getJssj()));
//        map.put("tzList",service.getTZList(list));
//        map.put("dhList",service.getDhList(list));
        return new ResultBean(map);
    }

    @RequestMapping("/getCnsb")
    @AuthFunction
    public ResultBean getCnsb(){
       List<EmSbcnp> list= emSbcnpService.list();
       Map<String,List<EmSbcnp>> map= list.stream().filter(l -> Objects.nonNull(l.getTzbh())).collect(Collectors.groupingBy(EmSbcnp::getTzbh));
       return new ResultBean(map);
    }
    @RequestMapping("/sygdPC")
    @AuthFunction
    public ResultBean sygdPC(){
        return service.sygdPC();
    }

    @RequestMapping("/saveList")
    @AuthFunction
    public ResultBean saveList( @RequestBody List<DmSygdMx> list ){
        service.saveBatch(list);
        //TODO 重新排产
        return new ResultBean();
    }

    @RequestMapping("/tqSygd")
    @AuthFunction
    public ResultBean tqSygd(@RequestBody  List<DmSygdMx> list){
        return service.tqSygd();
    }
}

