package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-09
 */
@RestController
@RequestMapping("/dmYdjh")
public class DmYdjhController {

    @Autowired
    private DmYdjhService service;

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody Map<String, String> map){
        List<DmYdjh> list= service.list(new QueryWrapper<DmYdjh>()
                .eq(StrUtil.isNotEmpty(map.get("dcCh")),"dc_ch",map.get("dcCh"))
                .eq(StrUtil.isNotEmpty(map.get("zt")),"zt",map.get("zt"))
                .ge(StrUtil.isNotEmpty(map.get("yf")), "jssj", DateUtil.beginOfMonth(DateUtil.parseDate(map.get("yf"))).toString("yyyy/MM/dd"))
                .le(StrUtil.isNotEmpty(map.get("yf")), "jssj", DateUtil.endOfMonth(DateUtil.parseDate(map.get("yf"))).toString("yyyy/MM/dd"))
                .orderByAsc("jssj,dc_ch,dc_pl,zl,lqlb")
        );
        return new ResultBean(list);
    }


    @RequestMapping("/hz")
    @AuthFunction
    public ResultBean hz(@RequestBody List<DmYdjh> list){
        return new ResultBean(service.hz(list));
    }

    @RequestMapping("/tj")
    @AuthFunction
    public ResultBean tj(@RequestBody List<DmYdjh> list){
        List<String> idList=list.stream().map(DmYdjh::getId).collect(Collectors.toList());
        service.update(new UpdateWrapper<DmYdjh>().set("zt","1")
                .in( "id",idList)
        );
        return new ResultBean();
    }




    @RequestMapping("/xf")
    @AuthFunction
    public ResultBean xf(@RequestBody List<DmYdjh> list){
            service.xf(list);
        return new ResultBean();
    }

}

