package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.date.DateUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jhgk.DmDhqdp;
import com.dsic.gj_erp.bean.jhgk.DmXbjh;
import com.dsic.gj_erp.mapper.jhgk.DmDhqdpMapper;
import com.dsic.gj_erp.service.jhgk.DmDhqdpService;
import com.google.common.collect.Maps;
import jdk.nashorn.internal.ir.annotations.Reference;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class DmDhqdpServiceImpl extends ServiceImpl<DmDhqdpMapper, DmDhqdp> implements DmDhqdpService {
    @Resource
    DmDhqdpMapper dmDhqdpMapper;

    @Override
    public List<DmDhqdp> getList(JSONObject json) {
        QueryWrapper<DmDhqdp> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("dcCh"))){
            queryWrapper.eq("DC_CH",json.getString("dcCh"));
        }
        if(StringUtils.isNotEmpty(json.getString("Zt"))){
            queryWrapper.eq("ZT",json.getString("Zt"));
        }
        List<DmDhqdp> dmDhqdps=dmDhqdpMapper.selectList(queryWrapper);
        return dmDhqdps;
    }

    @Override
    public List<DmDhqdp> save(List<DmDhqdp> dmDhqdps) {
        saveBatch(dmDhqdps);
        return dmDhqdps;
    }

    @Override
    public List<DmDhqdp> upload(MultipartFile file, HttpServletRequest req) throws IOException {
        ExcelReader reader= ExcelUtil.getReader(file.getInputStream());
        Map<String, String> alias = Maps.newLinkedHashMap();
        alias.put("船号", "dcCh");
        alias.put("订货清单号", "qdh");
        alias.put("期次", "qc");
        alias.put(" 材质\n" +
                "MATERIAL", "wpxh");
        //
        alias.put("厚度\r\n" +
                "THICK.\n" +
                "mm", "thickness");
        alias.put("宽度\r\n" +
                "WIDTH\n" +
                "mm", "width");
        alias.put("长度\r\n" +
                "LENGTH\n" +
                "mm", "length");
        alias.put("重量\r\n" +
                "吨/张\n" +
                "WEIGHT\n" +
                "TON/PIECE\r", "weight");
        //
        alias.put("设计数量\n" +
                "张\n" +
                "DESIGN\n" +
                "PIECE", "sjsl");
        alias.put("裕量\n" +
                "张\n" +
                "MARGIN\n" +
                "PIECE", "yl");
        alias.put("总数量\n" +
                "张\n" +
                "TOTAL\n" +
                "PIECE", "zsl");
        alias.put("总重量\n" +
                "吨\n" +
                "TOTAL\n" +
                "TON ", "zzl");
        alias.put("利库数量\n" +
                "张\n" +
                "STORE\n" +
                "PIECE", "lksl");
        alias.put("利库重量\n" +
                "吨\n" +
                "STORE\n" +
                "TON", "lkzl");
        alias.put("实订数量\n" +
                "张\n" +
                "ORDER\n" +
                "PIECE", "sdzs");
        alias.put("实订重量\n" +
                "吨\n" +
                "ORDER\n" +
                "TON", "sdzl");
        alias.put("备注\n" +
                "NOTE", "bz");
       // alias.put("状态", "zt");
        reader.setHeaderAlias(alias);
        List<DmDhqdp> dmDhqdps= reader.readAll(DmDhqdp.class);
        String day = DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        String user = (String) req.getAttribute("yhms");
        dmDhqdps.forEach(l->{
            this.remove(new QueryWrapper<DmDhqdp>().eq("Dc_ch",l.getDcCh())
                    .eq("qdh",l.getQdh())
                    .eq("qc",l.getQc()));
            l.setDrr(user);
            l.setDrrq(day);
        });
        return this.save(dmDhqdps);
    }

    @Override
    public void sh(List<DmDhqdp> dmDhqdps) {
        dmDhqdps.forEach(dmZrcjh -> {
            dmZrcjh.setZt("2");
        });
        updateBatchById(dmDhqdps);
    }

    @Override
    public void tj(List<DmDhqdp> dmXbjhs) {
        dmXbjhs.forEach(dmZrcjh -> {
            String zt=dmZrcjh.getZt();
            String setZt=zt.equals("1")?"0":"1";
            dmZrcjh.setZt(setZt);
        });
        updateBatchById(dmXbjhs);
    }
}
