package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.DmCzplpNew;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.excel.PlExcel;
import com.dsic.gj_erp.bean.jhgk.*;
import com.dsic.gj_erp.bean.jhgk.dto.*;
import com.dsic.gj_erp.mapper.jcsj.DmBomMapper;
import com.dsic.gj_erp.mapper.jcsj.EmGcrlMapper;
import com.dsic.gj_erp.mapper.jhgk.DmSygdMxMapper;
import com.dsic.gj_erp.mapper.jhgk.DmZrcjhMapper;
import com.dsic.gj_erp.service.jcsj.DmCzplpNewService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdService;
import com.dsic.gj_erp.service.jhgk.DmTzjhService;
import com.dsic.gj_erp.service.jhgk.DmXbjhService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@Service
public class DmSygdMxServiceImpl extends ServiceImpl<DmSygdMxMapper, DmSygdMx> implements DmSygdMxService {

    @Resource
    private EmGcrlMapper gcrlMapper;
    @Resource
    private DmSygdService sygdService;
    @Resource
    private DmXbjhService xbService;
    @Resource
    private DmTzjhService tzjhService;
    @Resource
    private DmSygdMxLjServiceImpl ljService;
    @Resource
    private EmSbcnpService sbcnpService;

    /**
     * 采购计划到货情况
     */
    public Object cgjhdhqk(Map<String, Object> map) {
        return baseMapper.cgjhdhqk(map);
    }

    /**
     * 三月滚动需求期排产
     * 滚动需求期信息，提取相应的BOM数据，后合并到套料图级别
     * 默认提取未来3个月信息
     *
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_UNCOMMITTED)
    public ResultBean sygdPC() {
        //todo 重复导入（三月滚动计划）的数据处理
        //零件 删除
        String begin=DateUtil.format(DateUtil.nextMonth(),"yyyy/MM/01");
        String end =DateUtil.format(DateUtil.endOfMonth(DateUtil.offsetMonth(DateUtil.date(),3)),"yyyy/MM/dd");
        //测试日期
//        String begin = "2023/08/01";
//        String end = "2023/10/31";
        //todo 零件
        ljService.remove(new QueryWrapper<DmSygdMxLj>().between("xzglxq", begin, end));
        //todo 三月滚动明细
        this.remove(new QueryWrapper<DmSygdMx>().between("jssj", begin, end));
        //todo 三月滚动计划
        sygdService.remove(new QueryWrapper<DmSygd>().between("sl_sj", begin, end));

        baseMapper.getLjxx(begin, end);
        List<DmSygdMxLj> ljList = ljService.list(new QueryWrapper<DmSygdMxLj>().between("xzglxq", begin, end));

        if (ljList.size() < 1) {
            return new ResultBean(false, 1, "请先导入" + begin + " ~ " + end + "分段钢料需求！");
        }

        //2.根据
        List<DmSygdMx> mxList = baseMapper.getMx(begin, end);
        //todo 排产
        ypc(mxList);
        baseMapper.setParent(begin, end);
        ResultBean r = new ResultBean(mxList);
        r.setSuccess(true);
        return r;
    }

    /**
     * 预排产，根据套料图号及跨位
     *
     * @param list
     */
    public void ypc(List<DmSygdMx> list) {
        Map<String, List<DmSygdMx>> mxMap = list.stream().collect(Collectors.groupingBy(x -> x.getKw() + x.getZl()));
        //加工工序list
        List<EmSbcnp> sbcnp = sbcnpService.list(new QueryWrapper<EmSbcnp>().orderByDesc("tzbh,zl,jgsx"));
        Map<String, List<EmSbcnp>> cnMap = sbcnp.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()));
        for (String ljkey : mxMap.keySet()) {
            for (String cnkey : cnMap.keySet()) {
                if (ljkey.equals(cnkey)) {
                    List<DmSygdMx> mxs = mxMap.get(ljkey);
                    List<EmSbcnp> cns = cnMap.get(cnkey);
                    //*******
                    mxs.forEach(l -> {
                        double ljgs = 0.0;
                        for (EmSbcnp cn : cns) {
                            // 号料 手工切割 倒棱 切端头 自由边 预组
                            // 曲 （个）
                            if (StrUtil.isNotEmpty(l.getQbs()) && cn.getGx().equals("18")) {
                                ljgs += l.getLjsl() / cn.getDegs();
                                l.setQjgrq(getRq(ljgs, l.getJssj()));
                            }

                            // 打磨
                            if (ObjectUtil.isNotEmpty(l.getDmcd()) && ("16,13".indexOf(cn.getGx()) > 0)) {
                                ljgs += l.getDmcd() / cn.getDegs();
                                l.setDmrq(getRq(ljgs, l.getJssj()));
                            }

                            // 坡口
                            if (ObjectUtil.isNotEmpty(l.getPkcd()) && ("08,10".indexOf(cn.getGx()) > 0)) {
                                ljgs += l.getPkcd() / cn.getDegs();
                                l.setPkrq(getRq(ljgs, l.getJssj()));
                            }

                            if ("03,04,05,07".indexOf(cn.getGx()) > 0) {
                                ljgs += l.getQgcd() / cn.getDegs();
                                l.setQgrq(getRq(ljgs, l.getJssj()));
                            }
                            // 划线
                            if (cn.getGx().equals("01")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setHxrq(getRq(ljgs, l.getJssj()));
                            }
                            //上料
                            if (cn.getGx().equals("19")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setSlrq(getRq(ljgs, l.getJssj()));
                            }
                            //抛丸
                            if (cn.getGx().equals("20")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setPkrq(getRq(ljgs, l.getJssj()));
                            }
                            //理料
                            if (cn.getGx().equals("21")) {
                                ljgs += l.getHxcd() / cn.getDegs();
                                l.setLlrq(getRq(ljgs, l.getJssj()));
                            }
                        }
                        this.save(l);
                    });

                }
            }
        }
//********************************************************************
        //1.根据组立结束时间排序，决定生产顺序
//        list = list.stream().sorted(Comparator.comparing(DmSygdMx::getQgjssj, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
//        double days=list.size()/266.0;
//        int day=(int)days;
//        day+=((days-day)>0?1:0);
//        //2.未来工厂日历信息
//        String begin=list.get(0).getJssj();
//        String end =DateUtil.format(DateUtil.offsetDay(DateUtil.parseDate(begin),day),"yyyy/MM/dd");
//        List<EmGcrl> gcrlList = gcrlMapper.selectList(new QueryWrapper<EmGcrl>()
//                                                      .between("gl",begin,end)
//                                                     .orderByAsc("gl"));
        //3.预排产
        // 假设：产能测算266.9；又套料图需当天完成
//        for (int i = 0; i < gcrlList.size(); i++) {
//            for (int j = 0; j < 266; j++) {
//                int index = 266 * i + j;
//                if (list.size() > index) {
//                   String sl= DateUtil.format(DateUtil.offsetDay(DateUtil.parseDate(gcrlList.get(i).getGl()),-1),"yyyy/MM/dd");
//                    list.get(index).setSlrq(sl);
//                    list.get(index).setPwrq(sl);
//                    list.get(index).setPw("1抛");
//                    list.get(index).setHxrq(gcrlList.get(i).getGl());
//                    list.get(index).setQgrq(gcrlList.get(i).getGl());
//                    list.get(index).setXxr(gcrlList.get(i).getXxr());
//                } else {
//                    j = 266;
//                    i = gcrlList.size();
//                }
//            }
//            //
//        }

//        this.saveBatch(list);
    }

    public String getRq(Double gs, String rq) {
        double ts = gs / 8;
        int num = (int) ts;
        num += (ts - num) > 0 ? 1 : 0;
        return DateUtil.format(DateUtil.offsetDay(DateUtil.parseDate(rq), -num), "yyyy/MM/dd");
    }


    /**
     * 提取线表信息
     *
     * @param list
     * @return
     */
    @Override
    public List<Xbjhdto> getXBList(List<DmSygdMx> list, String year, String begin, String end) {
        //
        //线表 年月 船号 重量
        //批量表重量 中日程重量
        //明细 按船号 月份 分组 计算重量 排产重量

        List<DmXbjh> xbjhs = xbService.list(new QueryWrapper<DmXbjh>()
                .eq("nf", year)
                .ne("zl", 0)
                .between("yf", begin, end));
        List<Xbjhdto> xbjhdtoList = BeanUtil.copyToList(xbjhs, Xbjhdto.class);

        //3.根据月份和船号分组
        Map<String, List<DmSygdMx>> monthAndCh = list.stream()
                .filter(mx -> Objects.nonNull(mx.getJssj())) // group by 的字段不能有null值
                .collect(Collectors.groupingBy(x -> x.getJssj().substring(5, 7) + x.getDcCh()));

        //4.
        xbjhdtoList.forEach(dmXbjh -> {
            for (String ch : monthAndCh.keySet()) {
                if (dmXbjh.getDcCh().equals(monthAndCh.get(ch).get(0).getDcCh())
                        && dmXbjh.getYf().equals(monthAndCh.get(ch).get(0).getJssj().substring(5, 7))) {
                    Double shzl = 0.0;
                    for (DmSygdMx mx : monthAndCh.get(ch)) {
                        shzl = shzl + (Objects.isNull(mx.getBcshzl()) ? 0.0 : mx.getBcshzl());
                    }
                    shzl = Double.valueOf(String.format("%.2f", Objects.isNull(shzl) ? shzl : shzl / 1000.0));
                    dmXbjh.setTlt_zl(shzl);
                    dmXbjh.setXczl(Double.valueOf(String.format("%.2f", shzl - dmXbjh.getZl())));
                    dmXbjh.setMxList(monthAndCh.get(ch));
                } else {
                    dmXbjh.setXczl(Double.valueOf(String.format("%.2f", 0.0 - dmXbjh.getZl())));
                }
            }
        });
        Map<String, List<Xbjhdto>> yf = xbjhdtoList.stream()
                .filter(mx -> Objects.nonNull(mx.getDcCh())) // group by 的字段不能有null值
                .collect(Collectors.groupingBy(x -> x.getYf()));
        List<Xbjhdto> list1 = new ArrayList<>();

        for (String month : yf.keySet()) {
            Double tlt_zl = 0.0;
            Double zl = 0.0;
            List<Xbjhdto> y = yf.get(month);
            for (Xbjhdto l : y) {
                tlt_zl = tlt_zl + l.getTlt_zl();
                zl = zl + l.getZl();
            }
            list1.addAll(yf.get(month));
            Xbjhdto xbjhdto = new Xbjhdto();
            xbjhdto.setDcCh("合计");
            xbjhdto.setXczl(Double.valueOf(String.format("%.2f", tlt_zl - zl)));
            xbjhdto.setTlt_zl(Double.valueOf(String.format("%.2f", tlt_zl)));
            xbjhdto.setZl(Double.valueOf(String.format("%.2f", zl)));
            xbjhdto.setYf(month);
            xbjhdto.setNf(y.get(0).getNf());
            list1.add(xbjhdto);
        }
        list1 = list1.stream()
                .sorted(Comparator.comparing(Xbjhdto::getYf)).collect(Collectors.toList());
        return list1;
    }

    /**
     * 提取批量表信息
     *
     * @return
     */
    @Override
    public List<Pldto> getPl(String begin, String end) {
        DmSygdMxLj one = ljService.getOne(new QueryWrapper<DmSygdMxLj>()
                .select("top 1 xzglxq ")
                .inSql("parent_id ", " SELECT dm_sygd_mx.id from dm_sygd_mx WHERE dm_sygd_mx.jssj BETWEEN '" + begin + "' and '" + end + "'")
                .orderByAsc("xzglxq"));

        DmSygdMxLj two = ljService.getOne(new QueryWrapper<DmSygdMxLj>()
                .select("top 1 xzglxq ")
                .inSql("parent_id ", " SELECT dm_sygd_mx.id from dm_sygd_mx WHERE dm_sygd_mx.jssj BETWEEN '" + begin + "' and '" + end + "'")
                .orderByDesc("xzglxq"));
        if (ObjectUtil.isAllNotEmpty(one,two)){
            List<Pldto> pldtoList = baseMapper.getPl(one.getXzglxq(), two.getXzglxq());
            return pldtoList;
        }
        return null;
    }

    /**
     * 提取跨位信息
     *
     * @param
     * @return
     */
    @Override
    public List<Kwdto> getKwList(List<DmSygdMx> list, String begin, String end) {
        List<Kwdto> kwdtoList = baseMapper.getkw(begin, end);

        kwdtoList.forEach(l -> {
            l.setMxList(list.stream().filter(
                    m -> m.getDcCh().equals(l.getCh())
                            && m.getDcPl().equals(l.getPl())
                            && (StrUtil.hasEmpty(m.getKw(), l.getKw()) ? true : m.getKw().equals(l.getKw()))
                            && m.getJssj().substring(0, 7).equals(l.getYf())
            ).collect(Collectors.toList()));

        });
        Map<String, List<Kwdto>> map = kwdtoList.stream().collect(Collectors.groupingBy(Kwdto::getYf));
        List<Kwdto> kws = new ArrayList<>();
        for (String yf : map.keySet()) {
            int count = list.stream().filter(
                    m -> m.getJssj().substring(0, 7).equals(yf)
            ).collect(Collectors.toList()).size();
            Kwdto k = new Kwdto();
            k.setYf(yf.substring(5, 7) + "月份合计");
            k.setBs(new BigDecimal(count));
            kws.add(k);
            kws.addAll(map.get(yf));
        }
        return kws;
    }

    public List<Kwdto> getKwList_n(List<DmSygdMx> list) {
        //1.将明细信息，按照跨位分组
        Map<String, List<DmSygdMx>> map = list.stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getKw()).orElse("")));
        List<Kwdto> kwdtoList = new ArrayList<>();
        //2.按照日期，统计每个跨位信息
        for (String kw : map.keySet()) {
            //TODO 根据上料日期分组
            Map<String, List<DmSygdMx>> map1 = map.get(kw).stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getSlrq()).orElse("无法")));
            for (String rq : map1.keySet()) {
                Kwdto kwdto = new Kwdto();
//                kwdto.setRq(rq);
                kwdto.setKw(kw);
                List<DmSygdMx> list1 = map1.get(rq);
//                kwdto.setTlt_sl(list1.size());
                BigDecimal hx_cd = new BigDecimal(0);
                BigDecimal qg_cd = new BigDecimal(0);
                for (DmSygdMx mx : list1) {
                    hx_cd = hx_cd.add(ObjectUtil.isEmpty(mx.getHxcd()) ? new BigDecimal(0) : new BigDecimal(mx.getHxcd()));
                    qg_cd = qg_cd.add(ObjectUtil.isEmpty(mx.getQgcd()) ? new BigDecimal(0) : new BigDecimal(mx.getQgcd()));
                }
//                kwdto.setHx_cd(hx_cd);
//                kwdto.setQg_cd(qg_cd);
                kwdto.setMxList(list1);
                kwdtoList.add(kwdto);
            }
        }
//        kwdtoList = kwdtoList.stream().sorted(Comparator.comparing(Kwdto::getRq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
        return kwdtoList;
    }

    /**
     * 提取图纸信息
     *
     * @param list
     * @return
     */
    @Override
    public List<Tzjhdto> getTZList(List<DmSygdMx> list) {
        //图纸计划 dmTzjh 船号 批量
        List<Tzjhdto> tzjhdtos = new ArrayList<>();
        Map<String, List<DmSygdMx>> map = list.stream().collect(Collectors.groupingBy(mx -> mx.getDcCh() + mx.getDcPl()));
        for (String key : map.keySet()) {
            List<DmSygdMx> list1 = map.get(key).stream().sorted(Comparator.comparing(DmSygdMx::getSlrq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
            DmTzjh tzjh = tzjhService.getOne(new QueryWrapper<DmTzjh>()
                    .select("DC_CH,DC_PL,xfq_lqb,jsq_lqb,xfq_tlt,jsq_tlt,stuff( ( SELECT ' ' + c.DC_FD FROM dm_tzjh c  WHERE c.DC_CH=dm_tzjh.DC_CH and c.DC_PL=dm_tzjh.DC_PL FOR xml path ( '' ) ), 1, 1, '' ) AS dcFd")
                    .eq("DC_CH", list1.get(0).getDcCh())
                    .eq("DC_PL", list1.get(0).getDcPl())
                    .groupBy("DC_CH,DC_PL,xfq_lqb,jsq_lqb,xfq_tlt,jsq_tlt"));
            if (ObjectUtil.isNotEmpty(tzjh)) {
                Tzjhdto tzjhdto = new Tzjhdto();
                BeanUtils.copyProperties(tzjh, tzjhdto);
                tzjhdto.setTzxqq(list1.get(0).getSlrq());//todo 使用上料日期作为需求期
                tzjhdto.setMxList(list1);
                tzjhdtos.add(tzjhdto);
            }
        }
        tzjhdtos = tzjhdtos.stream().sorted(Comparator.comparing(Tzjhdto::getTzxqq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
        return tzjhdtos;
    }

    /**
     * 提取到货信息
     *
     * @param list
     * @return
     */
    @Override
    public List<Dhdto> getDhList(List<DmSygdMx> list) {
        //船号 批量 订单号
//        Map<String, List<DmSygdMx>> map = list.stream()
//                .filter(mx -> Objects.nonNull(mx.getDhqd()))
//                .collect(Collectors.groupingBy(mx -> mx.getDcCh() + mx.getDcPl() + mx.getDhqd()));
//
        List<Dhdto> list1 = new ArrayList<>();
//        for (String key : map.keySet()) {
//            for (DmSygdMx mx : map.get(key)) {
//                Dhdto dhdto = new Dhdto();
//                List<DmSygdMx> mxs = new ArrayList<>();
//                dhdto.setDcCh(mx.getDcCh());
//                dhdto.setDcPl(mx.getDcPl());
//                dhdto.setDhqd(mx.getDhqd());
//                String[] str = mx.getWpgg().split("\\*");
//                dhdto.setWphd(str[0]);
//                dhdto.setWpkd(str[1]);
//                dhdto.setWpcd(str[2]);
//                dhdto.setRkxh(mx.getWpxh());
//                dhdto.setGcxqq(mx.getSlrq());
//                dhdto = baseMapper.getDhsl(dhdto);
//                mxs.add(mx);
//                dhdto.setMxList(mxs);
//                list1.add(dhdto);
//            }
//        }
        //以list为主
        return list1;
    }

    /**
     * 生成3月滚动计划
     *
     * @return
     */
    @Transactional
    public ResultBean tqSygd() {
        //1.查询未来3个月明细信息
        //测试
//        List<DmSygdMx> list=null;
        String begin = DateUtil.format(DateUtil.nextMonth(), "yyyy/MM/01");
        String end = DateUtil.format(DateUtil.endOfMonth(DateUtil.offsetMonth(DateUtil.date(), 3)), "yyyy/MM/dd");

        List<DmSygdMx> list = this.list(new QueryWrapper<DmSygdMx>()
                .between("jssj",
                        begin,
                        end)
                .orderByAsc("jssj")
        );
        if (ObjectUtil.isEmpty(list) || list.size() < 1) {
            return new ResultBean(null);
        }
        //根据船号+批量分组
        Map<String, List<DmSygdMx>> map = list.stream().collect(Collectors.groupingBy(x -> x.getDcCh() + x.getDcPl()));
        List<DmSygd> sygdList = new ArrayList<>();
        for (String key : map.keySet()) {
            DmSygd sygd = new DmSygd();
            List<DmSygdMx> mxList = map.get(key);
            sygd.setDcCh(mxList.get(0).getDcCh());
            sygd.setDcPl(mxList.get(0).getDcPl());
            sygd.setDcFd(mxList.get(0).getDcFd());
            sygd.setTltSl(mxList.size());
            sygd.setSlSj(mxList.get(0).getSlrq());
            sygd.setSlSl(mxList.size());
            sygd.setPwSj(mxList.get(0).getSlrq());
            sygd.setPwSl(mxList.size());
            sygd.setGjjsDz(mxList.get(0).getGjjsDz());
            sygd.setGjjsXz(mxList.get(0).getJssj());
            //跨位信息
            Map<String, List<DmSygdMx>> kwMap = map.get(key).stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getKw()).orElse("0")));
            for (String kw : kwMap.keySet()) {
                //组立信息
                Map<String, List<DmSygdMx>> zlMap = kwMap.get(kw).stream().collect(Collectors.groupingBy(x -> Optional.ofNullable(x.getZl()).orElse("0")));
                for (String zl : zlMap.keySet()) {
                    //跨位、组立下，多张套料图的最开始加工时间，最后加工时间；（上料日期）
                    List<DmSygdMx> kssj = zlMap.get(zl).stream().sorted(Comparator.comparing(DmSygdMx::getSlrq, Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
//                    List<DmSygdMx> jssj = zlMap.get(zl).stream().sorted(Comparator.comparing(DmSygdMx::getSlrq, Comparator.nullsLast(Comparator.naturalOrder())).reversed()).collect(Collectors.toList());

                    String sj = kssj.get(0).getSlrq();

                    if (kw.equals("7")) {//1跨平直大板
                        if (zl.equals("1110")) {//大组
                            sygd.setN1ad(kssj.size());
                            sygd.setN1adSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN1ax(kssj.size());
                            sygd.setN1axSj(sj);
                        }
                    }
                    if (kw.equals("8")) {//1跨进线板
                        sygd.setN1ld(kssj.size());
                        sygd.setN1ldSj(sj);
                    }
                    if (kw.equals("5")) {//2跨T型材面板
                        if (zl.equals("1110")) {//大组
                            sygd.setS2td(kssj.size());
                            sygd.setS2tdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setS2tx(kssj.size());
                            sygd.setS2txSj(sj);
                        }

                    }
                    if (kw.equals("9")) {//2跨超长超宽板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2bd(kssj.size());
                            sygd.setN2bdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2bx(kssj.size());
                            sygd.setN2bxSj(sj);
                        }
                    }
                    if (kw.equals("10")) {//2跨超长超宽曲板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2cd(kssj.size());
                            sygd.setN2cdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2cx(kssj.size());
                            sygd.setN2cxSj(sj);
                        }
                    }
                    if (kw.equals("11")) {//2跨T型材腹板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2td(kssj.size());
                            sygd.setN2tdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2tx(kssj.size());
                            sygd.setN2txSj(sj);
                        }
                    }
                    if (kw.equals("12")) {//2跨激光切割板
                        if (zl.equals("1110")) {//大组
                            sygd.setN2jd(kssj.size());
                            sygd.setN2jdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN2jx(kssj.size());
                            sygd.setN2jxSj(sj);
                        }

                    }
                    if (kw.equals("14")) {//3跨厚板
                        if (zl.equals("1110")) {//大组
                            sygd.setN3hd(kssj.size());
                            sygd.setN3hdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN3hx(kssj.size());
                            sygd.setN3hxSj(sj);
                        }

                    }
                    if (kw.equals("6")) {//3跨平铁
                        if (zl.equals("1110")) {//大组
                            sygd.setS3pd(kssj.size());
                            sygd.setS3pdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setS3px(kssj.size());
                            sygd.setS3pxSj(sj);
                        }
                        if (zl.equals("4230")) {//焊接机器人肘板
                            sygd.setS3xx(kssj.size());
                            sygd.setS3xxSj(sj);
                        }

                    }
                    if (kw.equals("13")) {//3跨曲板
                        if (zl.equals("1110")) {//大组
                            sygd.setN3cd(kssj.size());
                            sygd.setN3cdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN3cx(kssj.size());
                            sygd.setN3cxSj(sj);
                        }
                    }
                    if (kw.equals("15")) {//4跨普通板
                        if (zl.equals("1110")) {//大组
                            sygd.setN4pd(kssj.size());
                            sygd.setN4pdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setN4px(kssj.size());
                            sygd.setN4pxSj(sj);
                        }
                        if (zl.equals("4230")) {//焊接机器人肘板
                            sygd.setN4xx(kssj.size());
                            sygd.setN4xxSj(sj);
                        }

                    }
                    if (kw.equals("16")) {//7跨型板
                        if (zl.equals("1110")) {//大组
                            //todo 型材米数
                            sygd.setX7xd(kssj.size());
                            sygd.setX7xdSj(sj);
                        }
                        if (zl.equals("1010")) {//小组
                            sygd.setX7xx(kssj.size());
                            sygd.setX7xxSj(sj);
                        }
                    }
                    if (kw.equals("17")) {//光电
                        sygd.setN8gx(kssj.size());
                        sygd.setN8gxSj(sj);
                    }
                }
                //1跨 板数 加工 时间
                //1跨 板数 加工 时间
            }
            sygdService.remove(new QueryWrapper<DmSygd>().eq("DC_CH", sygd.getDcCh()).eq("DC_PL", sygd.getDcPl()));
            sygdList.add(sygd);
        }
        sygdList = sygdList.stream().sorted(Comparator.comparing(DmSygd::getDcCh).thenComparing(DmSygd::getDcPl)).collect(Collectors.toList());
        sygdService.saveBatch(sygdList);
        return new ResultBean(sygdList);
    }
}
